| Home | Libraries | People | FAQ | More

## Struct template unary_expr

boost::proto::unary_expr — A metafunction for generating unary expression types with a specified tag type, a grammar element for matching unary expressions, and a PrimitiveTransform that dispatches to the `proto::pass_through<>` transform.

## Synopsis

    // In header: <boost/proto/traits.hpp>

    template<typename Tag, typename T>
    struct unary_expr :  proto::transform< unary_expr<Tag, T> > {
      // types
      typedef proto::expr< Tag, proto::list1< T > >       type;
      typedef proto::basic_expr< Tag, proto::list1< T > > proto_grammar;

      // member classes/structs/unions
      template<typename Expr, typename State, typename Data>
      struct impl :
         proto::pass_through<unary_expr>::template impl<Expr, State, Data>
      {
      };
    };

## Description

Use `proto::unary_expr<proto::_, proto::_>` as a grammar element to match any unary expression.